//
// Contacts.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct Contacts: Codable, JSONEncodable, Hashable {

    public var id: Int?
    public var anniversary: Date?
    public var birthdate: Date?
    public var contactKeyNumeric: Double?
    public var ownerMemberKeyNumeric: Double?
    public var assistantEmail: String?
    public var assistantName: String?
    public var assistantPhone: String?
    public var assistantPhoneExt: String?
    public var businessFax: String?
    public var children: String?
    public var company: String?
    public var contactKey: String?
    public var contactLoginId: String?
    public var contactPassword: String?
    public var department: String?
    public var directPhone: String?
    public var email: String?
    public var email2: String?
    public var email3: String?
    public var firstName: String?
    public var fullName: String?
    public var homeAddress1: String?
    public var homeAddress2: String?
    public var homeCarrierRoute: String?
    public var homeCity: String?
    public var homeFax: String?
    public var homePhone: String?
    public var homePostalCode: String?
    public var homePostalCodePlus4: String?
    public var jobTitle: String?
    public var lastName: String?
    public var leadSource: String?
    public var middleName: String?
    public var mobilePhone: String?
    public var namePrefix: String?
    public var nameSuffix: String?
    public var nickname: String?
    public var notes: String?
    public var officePhone: String?
    public var officePhoneExt: String?
    public var originatingSystemContactKey: String?
    public var originatingSystemID: Double?
    public var originatingSystemName: String?
    public var otherAddress1: String?
    public var otherAddress2: String?
    public var otherCarrierRoute: String?
    public var otherCity: String?
    public var otherPostalCode: String?
    public var otherPostalCodePlus4: String?
    public var ownerMemberID: String?
    public var ownerMemberKey: String?
    public var pager: String?
    public var phoneTTYTDD: String?
    public var referredBy: String?
    public var sourceSystemContactKey: String?
    public var sourceSystemID: Double?
    public var sourceSystemName: String?
    public var spousePartnerName: String?
    public var tollFreePhone: String?
    public var voiceMail: String?
    public var voiceMailExt: String?
    public var workAddress1: String?
    public var workAddress2: String?
    public var workCarrierRoute: String?
    public var workCity: String?
    public var workPostalCode: String?
    public var workPostalCodePlus4: String?
    public var contactType: [String]?
    public var language: [String]?
    public var contactStatus: String?
    public var homeCountry: String?
    public var homeCountyOrParish: String?
    public var homeStateOrProvince: String?
    public var otherCountry: String?
    public var otherCountyOrParish: String?
    public var otherStateOrProvince: String?
    public var otherPhoneType: String?
    public var preferredAddress: String?
    public var preferredPhone: String?
    public var workCountry: String?
    public var workCountyOrParish: String?
    public var workStateOrProvince: String?
    public var modificationTimestamp: Date?
    public var originalEntryTimestamp: Date?
    public var ownerMember: Member?
    public var originatingSystem: OUID?
    public var sourceSystem: OUID?
    public var contactListingNotes: [ContactListingNotes]?
    public var contactListings: [ContactListings]?
    public var prospectings: [Prospecting]?

    public init(id: Int? = nil, anniversary: Date? = nil, birthdate: Date? = nil, contactKeyNumeric: Double? = nil, ownerMemberKeyNumeric: Double? = nil, assistantEmail: String? = nil, assistantName: String? = nil, assistantPhone: String? = nil, assistantPhoneExt: String? = nil, businessFax: String? = nil, children: String? = nil, company: String? = nil, contactKey: String? = nil, contactLoginId: String? = nil, contactPassword: String? = nil, department: String? = nil, directPhone: String? = nil, email: String? = nil, email2: String? = nil, email3: String? = nil, firstName: String? = nil, fullName: String? = nil, homeAddress1: String? = nil, homeAddress2: String? = nil, homeCarrierRoute: String? = nil, homeCity: String? = nil, homeFax: String? = nil, homePhone: String? = nil, homePostalCode: String? = nil, homePostalCodePlus4: String? = nil, jobTitle: String? = nil, lastName: String? = nil, leadSource: String? = nil, middleName: String? = nil, mobilePhone: String? = nil, namePrefix: String? = nil, nameSuffix: String? = nil, nickname: String? = nil, notes: String? = nil, officePhone: String? = nil, officePhoneExt: String? = nil, originatingSystemContactKey: String? = nil, originatingSystemID: Double? = nil, originatingSystemName: String? = nil, otherAddress1: String? = nil, otherAddress2: String? = nil, otherCarrierRoute: String? = nil, otherCity: String? = nil, otherPostalCode: String? = nil, otherPostalCodePlus4: String? = nil, ownerMemberID: String? = nil, ownerMemberKey: String? = nil, pager: String? = nil, phoneTTYTDD: String? = nil, referredBy: String? = nil, sourceSystemContactKey: String? = nil, sourceSystemID: Double? = nil, sourceSystemName: String? = nil, spousePartnerName: String? = nil, tollFreePhone: String? = nil, voiceMail: String? = nil, voiceMailExt: String? = nil, workAddress1: String? = nil, workAddress2: String? = nil, workCarrierRoute: String? = nil, workCity: String? = nil, workPostalCode: String? = nil, workPostalCodePlus4: String? = nil, contactType: [String]? = nil, language: [String]? = nil, contactStatus: String? = nil, homeCountry: String? = nil, homeCountyOrParish: String? = nil, homeStateOrProvince: String? = nil, otherCountry: String? = nil, otherCountyOrParish: String? = nil, otherStateOrProvince: String? = nil, otherPhoneType: String? = nil, preferredAddress: String? = nil, preferredPhone: String? = nil, workCountry: String? = nil, workCountyOrParish: String? = nil, workStateOrProvince: String? = nil, modificationTimestamp: Date? = nil, originalEntryTimestamp: Date? = nil, ownerMember: Member? = nil, originatingSystem: OUID? = nil, sourceSystem: OUID? = nil, contactListingNotes: [ContactListingNotes]? = nil, contactListings: [ContactListings]? = nil, prospectings: [Prospecting]? = nil) {
        self.id = id
        self.anniversary = anniversary
        self.birthdate = birthdate
        self.contactKeyNumeric = contactKeyNumeric
        self.ownerMemberKeyNumeric = ownerMemberKeyNumeric
        self.assistantEmail = assistantEmail
        self.assistantName = assistantName
        self.assistantPhone = assistantPhone
        self.assistantPhoneExt = assistantPhoneExt
        self.businessFax = businessFax
        self.children = children
        self.company = company
        self.contactKey = contactKey
        self.contactLoginId = contactLoginId
        self.contactPassword = contactPassword
        self.department = department
        self.directPhone = directPhone
        self.email = email
        self.email2 = email2
        self.email3 = email3
        self.firstName = firstName
        self.fullName = fullName
        self.homeAddress1 = homeAddress1
        self.homeAddress2 = homeAddress2
        self.homeCarrierRoute = homeCarrierRoute
        self.homeCity = homeCity
        self.homeFax = homeFax
        self.homePhone = homePhone
        self.homePostalCode = homePostalCode
        self.homePostalCodePlus4 = homePostalCodePlus4
        self.jobTitle = jobTitle
        self.lastName = lastName
        self.leadSource = leadSource
        self.middleName = middleName
        self.mobilePhone = mobilePhone
        self.namePrefix = namePrefix
        self.nameSuffix = nameSuffix
        self.nickname = nickname
        self.notes = notes
        self.officePhone = officePhone
        self.officePhoneExt = officePhoneExt
        self.originatingSystemContactKey = originatingSystemContactKey
        self.originatingSystemID = originatingSystemID
        self.originatingSystemName = originatingSystemName
        self.otherAddress1 = otherAddress1
        self.otherAddress2 = otherAddress2
        self.otherCarrierRoute = otherCarrierRoute
        self.otherCity = otherCity
        self.otherPostalCode = otherPostalCode
        self.otherPostalCodePlus4 = otherPostalCodePlus4
        self.ownerMemberID = ownerMemberID
        self.ownerMemberKey = ownerMemberKey
        self.pager = pager
        self.phoneTTYTDD = phoneTTYTDD
        self.referredBy = referredBy
        self.sourceSystemContactKey = sourceSystemContactKey
        self.sourceSystemID = sourceSystemID
        self.sourceSystemName = sourceSystemName
        self.spousePartnerName = spousePartnerName
        self.tollFreePhone = tollFreePhone
        self.voiceMail = voiceMail
        self.voiceMailExt = voiceMailExt
        self.workAddress1 = workAddress1
        self.workAddress2 = workAddress2
        self.workCarrierRoute = workCarrierRoute
        self.workCity = workCity
        self.workPostalCode = workPostalCode
        self.workPostalCodePlus4 = workPostalCodePlus4
        self.contactType = contactType
        self.language = language
        self.contactStatus = contactStatus
        self.homeCountry = homeCountry
        self.homeCountyOrParish = homeCountyOrParish
        self.homeStateOrProvince = homeStateOrProvince
        self.otherCountry = otherCountry
        self.otherCountyOrParish = otherCountyOrParish
        self.otherStateOrProvince = otherStateOrProvince
        self.otherPhoneType = otherPhoneType
        self.preferredAddress = preferredAddress
        self.preferredPhone = preferredPhone
        self.workCountry = workCountry
        self.workCountyOrParish = workCountyOrParish
        self.workStateOrProvince = workStateOrProvince
        self.modificationTimestamp = modificationTimestamp
        self.originalEntryTimestamp = originalEntryTimestamp
        self.ownerMember = ownerMember
        self.originatingSystem = originatingSystem
        self.sourceSystem = sourceSystem
        self.contactListingNotes = contactListingNotes
        self.contactListings = contactListings
        self.prospectings = prospectings
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case id
        case anniversary = "Anniversary"
        case birthdate = "Birthdate"
        case contactKeyNumeric = "ContactKeyNumeric"
        case ownerMemberKeyNumeric = "OwnerMemberKeyNumeric"
        case assistantEmail = "AssistantEmail"
        case assistantName = "AssistantName"
        case assistantPhone = "AssistantPhone"
        case assistantPhoneExt = "AssistantPhoneExt"
        case businessFax = "BusinessFax"
        case children = "Children"
        case company = "Company"
        case contactKey = "ContactKey"
        case contactLoginId = "ContactLoginId"
        case contactPassword = "ContactPassword"
        case department = "Department"
        case directPhone = "DirectPhone"
        case email = "Email"
        case email2 = "Email2"
        case email3 = "Email3"
        case firstName = "FirstName"
        case fullName = "FullName"
        case homeAddress1 = "HomeAddress1"
        case homeAddress2 = "HomeAddress2"
        case homeCarrierRoute = "HomeCarrierRoute"
        case homeCity = "HomeCity"
        case homeFax = "HomeFax"
        case homePhone = "HomePhone"
        case homePostalCode = "HomePostalCode"
        case homePostalCodePlus4 = "HomePostalCodePlus4"
        case jobTitle = "JobTitle"
        case lastName = "LastName"
        case leadSource = "LeadSource"
        case middleName = "MiddleName"
        case mobilePhone = "MobilePhone"
        case namePrefix = "NamePrefix"
        case nameSuffix = "NameSuffix"
        case nickname = "Nickname"
        case notes = "Notes"
        case officePhone = "OfficePhone"
        case officePhoneExt = "OfficePhoneExt"
        case originatingSystemContactKey = "OriginatingSystemContactKey"
        case originatingSystemID = "OriginatingSystemID"
        case originatingSystemName = "OriginatingSystemName"
        case otherAddress1 = "OtherAddress1"
        case otherAddress2 = "OtherAddress2"
        case otherCarrierRoute = "OtherCarrierRoute"
        case otherCity = "OtherCity"
        case otherPostalCode = "OtherPostalCode"
        case otherPostalCodePlus4 = "OtherPostalCodePlus4"
        case ownerMemberID = "OwnerMemberID"
        case ownerMemberKey = "OwnerMemberKey"
        case pager = "Pager"
        case phoneTTYTDD = "PhoneTTYTDD"
        case referredBy = "ReferredBy"
        case sourceSystemContactKey = "SourceSystemContactKey"
        case sourceSystemID = "SourceSystemID"
        case sourceSystemName = "SourceSystemName"
        case spousePartnerName = "SpousePartnerName"
        case tollFreePhone = "TollFreePhone"
        case voiceMail = "VoiceMail"
        case voiceMailExt = "VoiceMailExt"
        case workAddress1 = "WorkAddress1"
        case workAddress2 = "WorkAddress2"
        case workCarrierRoute = "WorkCarrierRoute"
        case workCity = "WorkCity"
        case workPostalCode = "WorkPostalCode"
        case workPostalCodePlus4 = "WorkPostalCodePlus4"
        case contactType = "ContactType"
        case language = "Language"
        case contactStatus = "ContactStatus"
        case homeCountry = "HomeCountry"
        case homeCountyOrParish = "HomeCountyOrParish"
        case homeStateOrProvince = "HomeStateOrProvince"
        case otherCountry = "OtherCountry"
        case otherCountyOrParish = "OtherCountyOrParish"
        case otherStateOrProvince = "OtherStateOrProvince"
        case otherPhoneType = "OtherPhoneType"
        case preferredAddress = "PreferredAddress"
        case preferredPhone = "PreferredPhone"
        case workCountry = "WorkCountry"
        case workCountyOrParish = "WorkCountyOrParish"
        case workStateOrProvince = "WorkStateOrProvince"
        case modificationTimestamp = "ModificationTimestamp"
        case originalEntryTimestamp = "OriginalEntryTimestamp"
        case ownerMember = "OwnerMember"
        case originatingSystem = "OriginatingSystem"
        case sourceSystem = "SourceSystem"
        case contactListingNotes = "ContactListingNotes"
        case contactListings = "ContactListings"
        case prospectings = "Prospectings"
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(id, forKey: .id)
        try container.encodeIfPresent(anniversary, forKey: .anniversary)
        try container.encodeIfPresent(birthdate, forKey: .birthdate)
        try container.encodeIfPresent(contactKeyNumeric, forKey: .contactKeyNumeric)
        try container.encodeIfPresent(ownerMemberKeyNumeric, forKey: .ownerMemberKeyNumeric)
        try container.encodeIfPresent(assistantEmail, forKey: .assistantEmail)
        try container.encodeIfPresent(assistantName, forKey: .assistantName)
        try container.encodeIfPresent(assistantPhone, forKey: .assistantPhone)
        try container.encodeIfPresent(assistantPhoneExt, forKey: .assistantPhoneExt)
        try container.encodeIfPresent(businessFax, forKey: .businessFax)
        try container.encodeIfPresent(children, forKey: .children)
        try container.encodeIfPresent(company, forKey: .company)
        try container.encodeIfPresent(contactKey, forKey: .contactKey)
        try container.encodeIfPresent(contactLoginId, forKey: .contactLoginId)
        try container.encodeIfPresent(contactPassword, forKey: .contactPassword)
        try container.encodeIfPresent(department, forKey: .department)
        try container.encodeIfPresent(directPhone, forKey: .directPhone)
        try container.encodeIfPresent(email, forKey: .email)
        try container.encodeIfPresent(email2, forKey: .email2)
        try container.encodeIfPresent(email3, forKey: .email3)
        try container.encodeIfPresent(firstName, forKey: .firstName)
        try container.encodeIfPresent(fullName, forKey: .fullName)
        try container.encodeIfPresent(homeAddress1, forKey: .homeAddress1)
        try container.encodeIfPresent(homeAddress2, forKey: .homeAddress2)
        try container.encodeIfPresent(homeCarrierRoute, forKey: .homeCarrierRoute)
        try container.encodeIfPresent(homeCity, forKey: .homeCity)
        try container.encodeIfPresent(homeFax, forKey: .homeFax)
        try container.encodeIfPresent(homePhone, forKey: .homePhone)
        try container.encodeIfPresent(homePostalCode, forKey: .homePostalCode)
        try container.encodeIfPresent(homePostalCodePlus4, forKey: .homePostalCodePlus4)
        try container.encodeIfPresent(jobTitle, forKey: .jobTitle)
        try container.encodeIfPresent(lastName, forKey: .lastName)
        try container.encodeIfPresent(leadSource, forKey: .leadSource)
        try container.encodeIfPresent(middleName, forKey: .middleName)
        try container.encodeIfPresent(mobilePhone, forKey: .mobilePhone)
        try container.encodeIfPresent(namePrefix, forKey: .namePrefix)
        try container.encodeIfPresent(nameSuffix, forKey: .nameSuffix)
        try container.encodeIfPresent(nickname, forKey: .nickname)
        try container.encodeIfPresent(notes, forKey: .notes)
        try container.encodeIfPresent(officePhone, forKey: .officePhone)
        try container.encodeIfPresent(officePhoneExt, forKey: .officePhoneExt)
        try container.encodeIfPresent(originatingSystemContactKey, forKey: .originatingSystemContactKey)
        try container.encodeIfPresent(originatingSystemID, forKey: .originatingSystemID)
        try container.encodeIfPresent(originatingSystemName, forKey: .originatingSystemName)
        try container.encodeIfPresent(otherAddress1, forKey: .otherAddress1)
        try container.encodeIfPresent(otherAddress2, forKey: .otherAddress2)
        try container.encodeIfPresent(otherCarrierRoute, forKey: .otherCarrierRoute)
        try container.encodeIfPresent(otherCity, forKey: .otherCity)
        try container.encodeIfPresent(otherPostalCode, forKey: .otherPostalCode)
        try container.encodeIfPresent(otherPostalCodePlus4, forKey: .otherPostalCodePlus4)
        try container.encodeIfPresent(ownerMemberID, forKey: .ownerMemberID)
        try container.encodeIfPresent(ownerMemberKey, forKey: .ownerMemberKey)
        try container.encodeIfPresent(pager, forKey: .pager)
        try container.encodeIfPresent(phoneTTYTDD, forKey: .phoneTTYTDD)
        try container.encodeIfPresent(referredBy, forKey: .referredBy)
        try container.encodeIfPresent(sourceSystemContactKey, forKey: .sourceSystemContactKey)
        try container.encodeIfPresent(sourceSystemID, forKey: .sourceSystemID)
        try container.encodeIfPresent(sourceSystemName, forKey: .sourceSystemName)
        try container.encodeIfPresent(spousePartnerName, forKey: .spousePartnerName)
        try container.encodeIfPresent(tollFreePhone, forKey: .tollFreePhone)
        try container.encodeIfPresent(voiceMail, forKey: .voiceMail)
        try container.encodeIfPresent(voiceMailExt, forKey: .voiceMailExt)
        try container.encodeIfPresent(workAddress1, forKey: .workAddress1)
        try container.encodeIfPresent(workAddress2, forKey: .workAddress2)
        try container.encodeIfPresent(workCarrierRoute, forKey: .workCarrierRoute)
        try container.encodeIfPresent(workCity, forKey: .workCity)
        try container.encodeIfPresent(workPostalCode, forKey: .workPostalCode)
        try container.encodeIfPresent(workPostalCodePlus4, forKey: .workPostalCodePlus4)
        try container.encodeIfPresent(contactType, forKey: .contactType)
        try container.encodeIfPresent(language, forKey: .language)
        try container.encodeIfPresent(contactStatus, forKey: .contactStatus)
        try container.encodeIfPresent(homeCountry, forKey: .homeCountry)
        try container.encodeIfPresent(homeCountyOrParish, forKey: .homeCountyOrParish)
        try container.encodeIfPresent(homeStateOrProvince, forKey: .homeStateOrProvince)
        try container.encodeIfPresent(otherCountry, forKey: .otherCountry)
        try container.encodeIfPresent(otherCountyOrParish, forKey: .otherCountyOrParish)
        try container.encodeIfPresent(otherStateOrProvince, forKey: .otherStateOrProvince)
        try container.encodeIfPresent(otherPhoneType, forKey: .otherPhoneType)
        try container.encodeIfPresent(preferredAddress, forKey: .preferredAddress)
        try container.encodeIfPresent(preferredPhone, forKey: .preferredPhone)
        try container.encodeIfPresent(workCountry, forKey: .workCountry)
        try container.encodeIfPresent(workCountyOrParish, forKey: .workCountyOrParish)
        try container.encodeIfPresent(workStateOrProvince, forKey: .workStateOrProvince)
        try container.encodeIfPresent(modificationTimestamp, forKey: .modificationTimestamp)
        try container.encodeIfPresent(originalEntryTimestamp, forKey: .originalEntryTimestamp)
        try container.encodeIfPresent(ownerMember, forKey: .ownerMember)
        try container.encodeIfPresent(originatingSystem, forKey: .originatingSystem)
        try container.encodeIfPresent(sourceSystem, forKey: .sourceSystem)
        try container.encodeIfPresent(contactListingNotes, forKey: .contactListingNotes)
        try container.encodeIfPresent(contactListings, forKey: .contactListings)
        try container.encodeIfPresent(prospectings, forKey: .prospectings)
    }
}

